//       FLYING SAUCERS


#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "metals.inc"

#declare GreySaucer =

union{
sphere{<0,6.94,0>,0.5}
difference{
sphere{<0,0.4256,0>,6.5}
cylinder{<0,-10,0>,<0,5.3,0>,16}
}
cylinder{<0,5,0>,<0,5.31,0>,4.2}
difference{
cylinder{<0,3,0>,<0,5.1,0>,4}
  cylinder{<0,4,-10>,<0,4,10>,0.5
   rotate<0,0,0>
   }
  cylinder{<0,4,-10>,<0,4,10>,0.5
   rotate<0,21,0>
   }
  cylinder{<0,4,-10>,<0,4,10>,0.5
   rotate<0,42,0>
   }
  cylinder{<0,4,-10>,<0,4,10>,0.5
   rotate<0,90,0>
   }
  cylinder{<0,4,-10>,<0,4,10>,0.5
   rotate<0,111,0>
   }
  cylinder{<0,4,-10>,<0,4,10>,0.5
   rotate<0,132,0>
   }
}
cylinder{<0,3,0>,<0,5,0>,3.9
   texture{pigment{color Gray15}}
   }
intersection{
difference{
sphere{<0,-12.49,0>,16}
sphere{<0,-15.2055,0>,18
   texture{pigment{color Gray40}}
   }
}
cone{<0,-12.49,0>,0,<0,4,0>,13.2026}
}
torus{9.875,0.2
   translate<0,-0.2,0>
   }
torus{7.3,0.8
   translate<0,0.75,0>
   }
sphere{<0,0,7>,1.5}
sphere{<-6.0622,0,-3.5>,1.5}
sphere{<6.0622,0,-3.5>,1.5}
texture{
   pigment{color Gray70}
   finish{phong 0.8 phong_size 30 metallic ambient 0.05}
   }
}

/////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////
// Textures

#declare cabinwall =
texture{
   pigment{color rgb <0.85, 0.8, 0.9>}
   finish{F_MetalB}}

#declare skirt =
texture{
   pigment{color rgb <0.85, 0.2, 0.3>}
   finish{F_MetalC}}

#declare dome =
texture{skirt}

#declare nob =
texture{
   pigment{color rgb <0.45, 0.42, 0.46>}
   finish{F_MetalB}}

#declare balls =
texture{
   pigment{color rgb <0.41, 0.43, 0.49>}
   finish{F_MetalB}}
//////////////////////////////////////////////////////////
//Red Saucer

// define the bits...

#declare Nob=
union{
difference{
  cylinder{<0,6.9256,-0.15>,<0,6.9256,0.15>,0.5}
  cylinder{<0,6.9256,-1>,<0,6.9256,1>,0.3}
  torus{0.4,0.02
    rotate<90,0,0>
    translate<0,6.9256,-0.15>}
  torus{0.4,0.02
    rotate<90,0,0>
    translate<0,6.9256,0.15>}
    texture{nob}
  }
torus{0.3,0.03
  rotate<90,0,0>
  translate<0,6.9256,0.1>
  texture{Bronze_Metal}}
torus{0.3,0.03
  rotate<90,0,0>
  translate<0,6.9256,0>
  texture{Bronze_Metal}}
torus{0.3,0.03
  rotate<90,0,0>
  translate<0,6.9256,-0.1>
  texture{Bronze_Metal}}
}

#declare Dome=
union{
difference{
  sphere{<0,0.4256,0>,6.5}
  cylinder{<0,-10,0>,<0,5.3,0>,16}
 }
cylinder{<0,6.92,0>,<0,6.929,0>,0.15}
sphere{<0,6.929,0>,0.01}
texture{dome}
}

#declare Cabin=
union{
  cylinder{<0,5,0>,<0,5.31,0>,4.2}
  difference{
   cylinder{<0,3,0>,<0,5.1,0>,4}
   cylinder{<0,4.15,-10>,<0,4.15,10>,0.5
    rotate<0,0,0>
   }
   cylinder{<0,4.15,-10>,<0,4.15,10>,0.5
    rotate<0,21,0>
   }
   cylinder{<0,4.15,-10>,<0,4.15,10>,0.5
    rotate<0,42,0>
   }
   cylinder{<0,4.15,-10>,<0,4.15,10>,0.5
    rotate<0,90,0>
   }
   cylinder{<0,4.15,-10>,<0,4.15,10>,0.5
    rotate<0,111,0>
   }
   cylinder{<0,4.15,-10>,<0,4.15,10>,0.5
    rotate<0,132,0>
   }
  }
  cylinder{<0,3,0>,<0,5,0>,3.9
   texture{pigment{color Gray15}}
   }
  torus{4.2,0.1
    translate<0,5.3,0>
  }
  cylinder{<0,3,0>,<0,3.3,0>,4.2}
  torus{4.2,0.1
    translate<0,3,0>
  }
  torus{4,0.2
    translate<0,3.3,0>
  }
  torus{4,0.2
    translate<0,5,0>
  }
texture{cabinwall}
}

#declare Skirt=
union{intersection{
  difference{
    sphere{<0,-12.49,0>,16}
    sphere{<0,-15.2055,0>,18
      texture{skirt}
    }
  }
  cone{<0,-12.49,0>,0,<0,4,0>,13.2026}
}
torus{9.875,0.2
   translate<0,-0.2,0>
}
torus{7.3,0.8
   translate<0,0.75,0>
}
texture{skirt}
}

#declare Balls=
union{
  sphere{<0,0,7>,1.5}
  sphere{<-6.0622,0,-3.5>,1.5}
  sphere{<6.0622,0,-3.5>,1.5}
    texture{balls}
}
////////////////////////////////////////////
#declare RedSaucer =
union{
  object{Nob}
  object{Dome}
  object{Cabin}
  object{Skirt}
  object{Balls}
  }



